# -*- coding: utf-8 -*-
"""
Created on Fri Dec 08 20:52:27 2017

@author: Joep
"""
from __future__ import division
import matplotlib.pyplot as plt
import matplotlib as mpl
from scipy.optimize import fsolve
import numpy as np
#from matplotlib2tikz import save as tikz_save
import math
import random
import os.path
from cycler import cycler
#import cloud.serialization.cloudpickle as clo
#import pickle
import time
import math

plot=plt.plot
mpl.rcParams['axes.prop_cycle'] = cycler('color', ['darkgreen', 'red','blue','orange'])+cycler('linestyle', ['-',  '--',':','-'])


n_end=10
n_st=n_end+5 #constant and shock





alpha =  0.877  #0.877
beta = 0.99;
theta = 1;

sigma = 3.845;
eta = 7.84; 
gamma = 4.481
omega = 0.75;
delta = (1-omega*beta)*(1-omega)/omega;
phi_y = 0.2378
phi_pi =1.821
phi_b = 1
phi_bg = 0
phi_cp_g = 0
phi_cp_ni =0
phi_pr_g =0
phi_pr_ni =-0
phi_pr_g_lag=-0


psi=0.0625
chi=1



rho_g=0.8503
rho_PR=0.9278
rho_CP=0.8412
    




gbar = 0.2;
taubar = 0.375;
Tbar=taubar






ybar=(1/(1-gbar)**sigma)**(1/(gamma+sigma))
bbar = (gbar-Tbar/ybar+(1/eta))/(1-1/beta)

lbar=ybar
cbar=ybar*(1-gbar)

s=1/eta



xi=sigma*gbar*(1-gbar)**(-1)/(gamma+(sigma/(1-gbar)));


Gammag = ((gamma+eta)*sigma*gbar)/((1-gbar)*eta*gamma);

zeta = ((1-beta)*gamma)/(beta*(gamma*(1-gbar)+sigma));
Gammay =  1+(1+gamma)/eta + ((eta+gamma)*sigma)/(eta*gamma*(1-gbar))

Gammatau =Tbar/ybar
Gammac = (1-gbar)+(sigma/gamma);

phi_yt=s*(gamma+sigma/(1-gbar)+1)/Gammatau;
phi_gt=phi_yt*xi-s/Gammatau*sigma*gbar/(1-gbar);
phi1 = (1-gbar)*(bbar*alpha*zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi2  = (1-gbar)*(1-alpha*(1-beta))/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi3 = (1-gbar)*alpha*beta*zeta*Gammatau/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi4 = (1-gbar)*psi*alpha*beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi5 = (1-gbar)*alpha*beta*(psi-zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi6 = (gbar-(1-gbar)*beta*alpha*Gammag*zeta-xi*(1-(1-gbar)*alpha*beta*Gammay*zeta))/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi7= (1-gbar)*((1-alpha)+alpha*beta)/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi8 = beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi9 = (1-gbar)*alpha*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi10 = (1-gbar)*(1-alpha)*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi11 = (1-gbar)*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi12 = beta*(gbar-xi)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi13 = (1-alpha)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi14 = (1-gbar)*(1-alpha)/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi15 = (1-alpha)*(gbar-xi)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
#phi16 = (1-alpha)*beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi17 = (1-alpha)*beta*(gbar-xi)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi18 = (1-gbar)*alpha*zeta*bbar/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi19 = (1-gbar)*alpha*psi/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi20 = (1-gbar)*alpha*(psi-zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);


#phi_yt=s*(gamma+sigma/(1-gbar)+1)/Gammatau
#phi8 = beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi12 = (1-alpha)*theta**2/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi9 = (1-gbar)*alpha*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#phi1 = (1-gbar)*(bbar*alpha*zeta*sigma)/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#phi13 = (1-gbar)*(1-alpha)*theta**2/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#phi15 = (1-gbar)*alpha*zeta*bbar/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi2  = (1-gbar)*(1-alpha*(1-beta))/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#phi10 = (1-gbar)*(1-alpha)*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#phi17 = (1-gbar)*alpha*(psi-zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi5 = (1-gbar)*alpha*beta*(psi-zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi3 = (1-gbar)*alpha*beta*zeta*Gammatau/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi16 = (1-gbar)*alpha*psi/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi4 = (1-gbar)*alpha*beta*psi/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2);
#phi7= (1-gbar)*((1-alpha)+alpha*beta)/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#phi11 = (1-gbar)*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta*theta**2)*sigma);
#



#used as LHS


#y, pi, i, b, tau, br,cr, gshock, yshock, pishock
A=np.array([[1,phi1+phi10,phi2,phi4,phi3,-phi5,0,-(phi6+phi17),-(phi7+phi10),0],
            [-delta*(gamma+sigma/(1-gbar)),1,0,0,0,0,0,0,0,-1],
            [-phi_y,-phi_pi,1,0,0,0,0,0,0,0],
            [0,bbar/beta,0,1,0,0,0,-gbar,0,0],
            [-phi_yt, 0, 0, 0,1,0,0,-phi_gt,0,0],
            [-Gammay,bbar/beta,0,0,Gammatau,1,Gammac,-(Gammay*xi-Gammag),0,0],        
            [-1/(alpha*(1-gbar)),0,-(1-alpha)/(alpha*sigma),0,0,0,1,-(xi-gbar)/(alpha*(1-gbar)),(1-alpha)/(alpha*sigma),0],    
            [0,0,0,0,0,0,0,1,0,0],
            [0,0,0,0,0,0,0,0,1,0],
            [0,0,0,0,0,0,0,0,0,1]
            ])




Ainv=np.linalg.inv(A)





def eval_plm(vec_lag,x,var,n_end,n_st):
    som=0
    for ij in range(n_st):    
        som+=vec_lag[ij]*x[ij*n_end+var]
    return som

def eval_msv(msv,var,vec_lag):
    som=msv[0][var]
    for y in range(1,n_st-1):
        som+=msv[y][var]*vec_lag[y]
    return som



#y, pi, i, b, tau, br, cr,  ischock, tauschok
def calc_RHS(vec_lag,vec_next):
    RHStot=[0]*n_end 
    RHStot[0]=phi8*vec_next[0]+phi13*vec_lag[0]+phi9*vec_next[1]+phi14*vec_lag[1]+phi18*vec_lag[2]+phi10*vec_next[2]\
             -phi20*vec_lag[5]+phi19*vec_lag[3]-phi11*vec_next[8]-phi14*vec_lag[8]-phi12*vec_next[7]-phi15*vec_lag[7]          
    RHStot[1]= beta*vec_next[1] 
    RHStot[2]=0       
    RHStot[3]=(1/beta-Gammatau*phi_b)*vec_lag[3]+bbar/beta*vec_lag[2]-Gammatau*vec_lag[13] 
    RHStot[4]=phi_b*vec_lag[3]+vec_lag[13] 
    RHStot[5]=1/beta*vec_lag[5]+bbar/beta*vec_lag[2] 
    RHStot[6]=-(1-alpha)/(alpha*(1-gbar))*(vec_lag[0]+(xi-gbar)*vec_lag[7])-(1-alpha)/(alpha*sigma)*(vec_lag[1]-vec_lag[8])\
                +psi*vec_lag[5]-psi*vec_lag[3]    
    RHStot[7]=rho_g*vec_lag[7]+vec_lag[10]
    RHStot[8]=rho_PR*vec_lag[8]+vec_lag[11]
    RHStot[9]=rho_CP*vec_lag[9]+vec_lag[12]

    return RHStot



def statefunc(x,bl_zlb=0): 
    # state variables are: a constant (later think about zlb and DS), Y-1,p-1,s-1,B-1,ni-1,g-1,tau-1, innovation of prefshock    

    RHS=[0]*len(x)
    stackvec=[0]*len(x)
    
    for jj in range(n_st):
        vec_lag=np.zeros(n_st)
        vec_lag[jj]=1
        vec=np.zeros(n_st) 
#        vec_endo=np.zeros(n_st)
        vec_next=np.zeros(n_end)   
        
        #calcualte current period

        if jj==n_st-1:
            vec[n_st-1]=1 # we are interested in constants, also after one iteration. 
    
        for hh in range(0,n_end): # normal state verianbels. not for constant and ex shock
            var=hh
            vec[hh]=eval_plm(vec_lag,x,var,n_end,n_st)
   
        #calcualte next period
        for hi in range(0, n_end):
            var=hi
            vec_next[hi]=eval_plm(vec,x,var,n_end,n_st)
            

        RHS[n_end*jj:n_end*jj+n_end]=calc_RHS(vec_lag,vec_next)


        stackvec[n_end*jj:n_end+n_end*jj]=np.dot(np.array(Ainv),np.array(RHS[n_end*jj:n_end+n_end*jj]))
    equations=[]
    for i in range(len(x)):
        equations.append(stackvec[i]-x[i])
    return equations
#
#




PRsk=0
CPsk=1


N=43 #simualte N periods  




       
#
#init=msv_coefs
init=[0]*n_st*n_end

[msv_coefs,inf,ier,mes] = fsolve(statefunc, init,full_output=1)  

if ier != 1:
    print( mes)
    
#save MSV
[msv_lY,msv_lPi,msv_lni,msv_lB,msv_ltau,msv_lbr,msv_lcr,
 msv_pers_shockg,msv_pers_shockPR,msv_pers_shockCP,
 msv_shock_g,msv_shock_PR,msv_shock_CP,msv_shock_tau,msv_constants
 ]=[msv_coefs[ij*n_end:ij*n_end+n_end] for ij in range(n_st)]


#initialize variables for simulation  
Y,Pi,ni,B,tau,br,cr,rrb,rrr,bb,cb,cexpr,cexpb,cexpbr,cexpbr2,cbr,cbr2,cexpbr3,cbr3=[np.zeros(N) for _ in range(19)]
g,shockg,shocktau,PR,CP,shockPR,shockCP=[np.zeros(N) for _ in range(7)]



#EY,EPi,Eni,EB,Eg,Etau,Ebr,Ecr,Emps,Ets,Egs,EPR,ECP=[np.zeros(N) for _ in range(n_end)]
     
        
        
        

               #y, pi, i, b, tau, br, cr, pr
for i in range(1,N):

    if i==1: #in period 1 we shock the model and then simulate further
        if CPsk==1:
            shockCP[i]=0.0164#*np.random.randn()

        if PRsk==1:
            shockPR[i]=0.0187 #*np.random.randn()  
        else:
             shockg[i]=0.0225 

#        sh_Pi[i]=0.01
  

    
    [Y[i],Pi[i],ni[i],B[i],tau[i],br[i],cr[i],g[i],PR[i],CP[i]]=[
            msv_constants[hh]+msv_shock_PR[hh]*shockPR[i]+msv_shock_CP[hh]*shockCP[i]+msv_shock_g[hh]*shockg[i]+msv_shock_tau[hh]*shocktau[i]
            +msv_lY[hh]*Y[i-1]+msv_lPi[hh]*Pi[i-1]
            +msv_lni[hh]*ni[i-1]+msv_lB[hh]*B[i-1]+msv_ltau[hh]*tau[i-1]+msv_lbr[hh]*br[i-1]+msv_lcr[hh]*cr[i-1]
            +msv_pers_shockg[hh]*g[i-1]+msv_pers_shockPR[hh]*PR[i-1]+msv_pers_shockCP[hh]*CP[i-1]   for hh in range(n_end)]
    
#    [EY[i],EPi[i],Eni[i],EB[i],Eg[i],Etau[i],Ebr[i],Ecr[i],Egs[i],Emps[i],Ets[i],EPR[i],ECP[i]]=[
#            msv_constants[hh]+msv_lY[hh]*Y_msv[i]+msv_lPi[hh]*Pi_msv[i]+msv_lni[hh]*ni_msv[i]+msv_lB[hh]*B_msv[i]+
#            msv_lg[hh]*g_msv[i]+msv_ltau[hh]*tau_msv[i]+msv_lbr[hh]*br_msv[i]+msv_lcr[hh]*cr_msv[i]
#            +msv_pers_shockg[hh]*gs_msv[i]+msv_pers_shocki[hh]*mps_msv[i]+msv_pers_shocktau[hh]*ts_msv[i] 
#            +msv_pers_shockPR[hh]*PR_msv[i]+msv_pers_shockCP[hh]*CP_msv[i]   for hh in range(n_end)]
#    
#  
      
    #        bounded rational consumption
    
    
    #//government spending shock

#     
    
    if alpha<1:
        bb[i]= 1/(1-alpha)*B[i]-alpha/(1-alpha)*br[i]
        cb[i]=1/(1-alpha)*(Y[i])/(1-gbar)-alpha/(1-alpha)*cr[i]-(gbar-xi)/(1-alpha)*(g[i])/(1-gbar)
#
#    w[i]=(gamma+sigma/(1-gbar))*Y[i]-sigma/(1-gbar)*g[i]+1/(taubar)*tau[i]
#    lb[i]=1/gamma*(w[i]-sigma*cb[i]-tau[i]/(1-taubar))
#    lr[i]=1/gamma*(w[i]-sigma*cr[i]-tau[i]/(1-taubar))
    
    cexpb[i]=1/(1-gbar)*Y[i-1]+psi*(bb[i-1]-B[i-1])-(gbar-xi)*g[i-1]/(1-gbar)
   
for i in range(1,N-1):    
    cexpr[i]=cr[i+1]
    
    rrb[i]=ni[i]-theta**2 *Pi[i-1]
    rrr[i]=ni[i]-Pi[i+1]
    cexpbr[i]=Y[i+1]/(1-gbar)-(gbar-xi)*g[i+1]/(1-gbar)+psi*(bb[i-1]-B[i-1])
    cexpbr2[i]=Y[i+1]/(1-gbar)-(gbar-xi)*g[i+1]/(1-gbar)
    cexpbr3[i]=cb[i+1]
    cbr[i]=cexpbr[i]-1/sigma*rrr[i]+1/sigma*(PR[i]-PR[i+1])
    cbr2[i]=cexpbr2[i]-1/sigma*rrr[i]+1/sigma*(PR[i]-PR[i+1])      
    cbr3[i]=cexpbr3[i]-1/sigma*rrr[i]+1/sigma*(PR[i]-PR[i+1])   
#level_Cr=(1+cr)*cbar
#level_Cb=(1+cb)*cbar
#level_Lr=(1+lr)*lbar
#level_Lb=(1+lb)*lbar
#
#ss_per_u=cbar**(1-sigma)/(1-sigma)-chi*lbar**(1+gamma)/(1+gamma)       
#per_U_br=(level_Cb**(1-sigma)/(1-sigma)-chi*level_Lb**(1+gamma)/(1+gamma)-ss_per_u)/ss_per_u*100
#betalist=[beta**i for i in range(len(per_U_br))]
#U_br_nondisc=np.sum(per_U_br)
#U_br_disc=np.sum(per_U_br*betalist)
#per_U_r=(level_Cr**(1-sigma)/(1-sigma)-chi*level_Lr**(1+gamma)/(1+gamma)-ss_per_u)/ss_per_u*100
#U_r_disc=np.sum(per_U_r*betalist)
#U_r_nondisc=np.sum(per_U_r)
#









#%%     



plt.figure(3)      
plt.subplot(2, 2, 1)
plot([Y[i]*100 for i in range(1,N)],linewidth=2)
plt.title('Output')
plt.ylabel('X_t')
plt.xlabel('t')


  
plt.subplot(2, 2, 2)
plot([Pi[i]*100 for i in range(1,N)],linewidth=2)
plt.title('Inflation')
plt.ylabel('Pi_t')
plt.xlabel('t')


#%%

if PRsk==1:
    plt.subplot(2, 2, 3)
    plot([(PR[i])*100 for i in range(1,N)],linewidth=3)
    plt.title('Preference shock')
    plt.xlabel('t')
else: 

    plt.subplot(2, 2, 3)
    plot([(CP[i])*100 for i in range(1,N)],linewidth=2)
    plt.title('Cost Push shock')
    plt.xlabel('t')


   
plt.subplot(2, 2, 4)
plot([ni[i]*100 for i in range(1,N)],linewidth=2)
plt.title('Nominal Interest Rate')
plt.ylabel('i_t')
plt.xlabel('t')
 



plt.figure(4)   

plt.subplot(2, 2, 1)
plot([cexpr[i]*100 for i in range(1,N-1)],linewidth=2)
plot([cexpb[i]*100 for i in range(1,N-1)],linewidth=2)
#plot([cexpbr[i]*100 for i in range(1,N)],linewidth=2)
#plot([cexpbr2[i]*100 for i in range(1,N)],linewidth=2)
#plot([cexpbr3[i]*100 for i in range(1,N)],linewidth=2)
plt.title('Cons exp')


plt.subplot(2, 2, 2)
plot([rrr[i]*100 for i in range(1,N)],linewidth=2)
plot([rrb[i]*100 for i in range(1,N)],linewidth=2)
plt.title('real interestrate exp')

plt.subplot(2, 2, 3)
plot([cr[i]*100 for i in range(1,N)],linewidth=2)
plot([cb[i]*100 for i in range(1,N)],linewidth=2)
#plot([cbr[i]*100 for i in range(1,N)],linewidth=2)
#plot([cbr2[i]*100 for i in range(1,N)],linewidth=2)
#plot([cbr3[i]*100 for i in range(1,N)],linewidth=2)
plt.title('Cons')

plt.subplot(2, 2, 4)
plot([br[i]*100 for i in range(1,N)],linewidth=2)
plot([bb[i]*100 for i in range(1,N)],linewidth=2)
# plot([B[i]*100 for i in range(1,N)],linewidth=2)
plt.title('bonds')

# for  i in range(1,N-2):
#     print(i,cr[i]*100)

plt.figure(5)   
plot([cr[i]*100 for i in range(1,N)],linewidth=2)
plot([cb[i]*100 for i in range(1,N)],linewidth=2)
plot([cbr[i]*100 for i in range(1,N)],linewidth=2)
plt.title('Cons')
    
   

  